﻿Option Explicit On
Option Strict Off
Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_80_Mask_91
Imports NM_Ahnen.cls_30_Search
Imports NM_Ahnen
Imports NM_Ahnen.NM_Ahnen_Search
Imports NM_Ahnen.NM_Print

Public Class Cls_40_Print_Nachfahren
    Private WithEvents PrintDoc As New System.Drawing.Printing.PrintDocument
    'PrintDoc.DefaultPageSettings.Landscape = Querformat

    REM *******************************************************
    REM *  Ermitteln der Startperson
    REM *  Generationszähler auf Null stellen
    REM *  Tabelleninsertzähler = 0
    REM *  Daten in Tabelle eintragen (PersonenNr., Generation, Elternnr. KekuleNr.
    REM *  Tabellenlesezähler = Null

    REM *  Startpunkt 1
    REM *  Dazulesen der Eltern (Vater, wenn vorhanden)
    REM *  Generationszähler erhöhen
    REM *  KekuleNr. ermitteln
    REM *  Tabelleninsertzähler um 1 erhöhen
    REM *  Daten in Tabelle eintragen (s.o.)

    REM *  Dazulesen der Eltern (Mutter, wenn vorhanden)
    REM *  Generationszähler erhöhen
    REM *  KekuleNr. ermitteln
    REM *  Tabelleninsertzähler um 1 erhöhen
    REM *  Daten in Tabelle eintragen (s.o.)

    REM *  Tabellenlesezähler um 1 erhöhen
    REM *  Weiter bei Startpunkt 1


    Public Shared Sub Nachfahren()

        int_Merk_Liste = 2
        NM_Print.Show()

    End Sub

    REM ***************************************************************************
    REM *  Daten der Startperson laden                                            *
    REM ***************************************************************************
    Public Shared Sub Read_Start_Person_Nachfahren()

        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Gen_NF_High = int_Anz + 1
        Dim i66 As Integer
        Dim i67 As Integer
        Gen_Nach_Max = 12
        Gen_Lg = 5

        REM *  Dimensionieren der Hilfstabellen
        ReDim Gen_NF(int_Anz, Gen_Nach_Max)
        ReDim Gen_NFS(int_Anz, Gen_Nach_Max)
        ReDim Gen_AltID(Gen_Nach_Max)
        ReDim Gen_Alter(Gen_Nach_Max)
        ReDim Gen_ID(int_Anz)
        ReDim Gen_Stufe(int_Anz)

        For i66 = 0 To int_Anz
            For i67 = 0 To Gen_Nach_Max
                Gen_NF(i66, i67) = 0
                Gen_NFS(i66, i67) = 0
            Next i67
            Gen_ID(i66) = 0
            Gen_Stufe(i66) = 0
        Next i66

        For i66 = 0 To Gen_Nach_Max
            Gen_AltID(i66) = 0
            Gen_Alter(i66) = 999999
        Next

        REM *  Startwerte setzen
        Gen_Tab_Ins = 0
        Gen_Tab_Read = 0
        Gen_Kek = 1
        Gen_Stuf = 0

        dbl_ID = NM_Print.tx_P_ID.Text

        REM *  Daten der Startperson lesen
        Call Person_Read_t01_Basis()
        Gen_ID(0) = dbl_ID

        REM *  Daten in Hilfstabellen einfügen
        Gen_NF(0, 0) = dbl_ID   REM Startperson wird auf 0,0 fixiert
        int_T1 = -1
        Call Read_Kinder()
        Call Nachfahren_Tab_Read()
        Call Tab_Nachfahren_Aufbau()

    End Sub

    REM *****************************************************
    REM *  Die Daten der Nachfahren lesen und einfügen      *
    REM *****************************************************
    Public Shared Sub Nachfahren_Tab_Read()

        Dim i63 As Integer
Tab_Read_Start:
        If Gen_Tab_Read > int_T1 Then
            Exit Sub
        End If
        int_T3 = Gen_Tab_Read

        For i63 = 1 To Gen_Nach_Max
            If Gen_NF(int_T3, i63) = 0 Then
                Gen_Tab_Read += 1
                Gen_Stuf = Gen_Stufe(Gen_Tab_Read - 1)
                GoTo Tab_Read_Start
            Else
                dbl_ID = Gen_NF(int_T3, i63)
                Call Read_Kinder()
            End If
        Next

    End Sub

    REM ***************************************************
    REM *  Lesen der Kindsdaten aus Rollenfunktion 3      *
    REM ***************************************************
    Public Shared Sub Read_Kinder()

        Dim reader As OleDbDataReader
        int_T2 = 0
        Dim int_Pers As Long

        str_Where = " where t05_FK_t01 = " + dbl_ID.ToString + " and t05_Typ = 3"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where

        For i66 = 0 To Gen_Nach_Max
            Gen_AltID(i66) = 0
            Gen_Alter(i66) = 999999
        Next
        int_T1 += 1
        Gen_NF(int_T1, int_T2) = dbl_ID

        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then

                Do While reader.Read()
                    int_Pers = reader.Item("t05_FK_Rolle")
                    int_T2 += 1
                    Gen_AltID(int_T2) = int_Pers
                Loop
            End If
            reader.Close()
            Gen_Stuf += 1
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        Call Nachfahren_Sort()

    End Sub

    REM *********************************************************
    REM *  Sortieren der Kinderzeile in Altersfolge             *
    REM *********************************************************
    Public Shared Sub Nachfahren_Sort()
        Dim Indexlist As New List(Of Sortfelder)

        Dim GEN_GDat As String

        For i62 = 1 To Gen_Nach_Max
            If Gen_AltID(i62) > 0 Then
                dbl_ID = Gen_AltID(i62)
                Call Person_Read_t01_Basis()
                GEN_GDat = p_str_GDat_JJ + p_str_GDat_MM
                Gen_Alter(i62) = Val(GEN_GDat)
            End If
            Dim flds = New Sortfelder With {.Feld1 = Gen_Alter(i62), .Feld2 = Gen_AltID(i62), .Feld3 = Gen_Stufe(i62)}
            Indexlist.Add(flds)
        Next
        Indexlist.Sort(Function(x, y) x.Feld1.CompareTo(y.Feld1))
        Dim i70 As Integer = 1
        For i62 = 0 To (Gen_Nach_Max - 1)
            If Indexlist(i62).Feld2 > 0 Then
                Gen_NF(int_T1, i70) = Indexlist(i62).Feld2
                Gen_NFS(int_T1, i70) = Indexlist(i62).Feld3
                i70 += 1
            End If
        Next

    End Sub

    REM ***************************************************
    REM Hilfstabellen füllen                              *
    REM ***************************************************
    Public Shared Sub Tab_Nachfahren_Aufbau()
        Dim iTab As Integer = 0
        Dim iTx As Integer = 0

        ReDim Gen_x1(Gen_NF_High)
        ReDim Gen_x2(Gen_NF_High)
        ReDim Gen_Help(Gen_NF_High)
        For i65 = 0 To Gen_NF_High
            Gen_x1(i65) = 0
            Gen_x2(i65) = 0
            Gen_Help(i65) = ""
        Next

        For i65 = 0 To 200
            For i66 = 0 To Gen_Nach_Max
                Gen_x1(iTab) = Gen_NF(i65, 0)
                Gen_x2(iTab) = Gen_NF(i65, i66)
                If Gen_x1(iTab) <> Gen_x2(iTab) And Gen_x2(iTab) > 0 Then
                    Gen_Help(iTx) = Gen_x1(iTab).ToString("00000") + Gen_x2(iTab).ToString("00000")
                    iTx += 1
                End If
                iTab += 1
            Next
        Next
        Call Test(iTx - 1)

    End Sub

    REM ***********************************************************
    REM *  Hilfsstring abarbeiten und Folgegeneration ermitteln   *
    REM ***********************************************************
    Public Shared Sub Test(ByVal i22 As Integer)

        Dim T1 As String
        Dim T2 As String
        Dim iL As Integer
        Dim iPos As Integer
        Dim iPos1 As Integer
        ReDim T_Search(Gen_Nach_Max)

        REM *  Startperson
        iT = 0
        Gen_ID(iT) = Mid(Gen_Help(0), 1, 5)
        Gen_Stufe(Gen_Stuf) = 0
        Gen_Start = Mid(Gen_Help(0), 1, 5)
        For i88 = 0 To i22
            'If iT > i22 Then Exit For
            If Gen_Help(i88) = "" Then Exit For
            For i = 0 To Gen_Nach_Max
                T_Search(i) = ""
            Next
            T_Search(Gen_Stuf) = Mid(Gen_Help(0), 1, 5)

            Gen_Stuf = 1
            iL = Len(Gen_Help(i88))
            iPos = Gen_Lg + 1
            iPos1 = Gen_Lg
            If iL >= (Gen_Lg * 2) Then iPos = iL - (Gen_Lg - 1) : iPos1 = iL - Gen_Lg
            T1 = Mid(Gen_Help(i88), 1, iPos1)
            T2 = Mid(Gen_Help(i88), iPos, Gen_Lg)
            If T1 <> Gen_Start Then GoTo NF_Ex100

            If T2 > "" Then
                iT += 1
                Gen_ID(iT) = T2
                T_Search(Gen_Stuf) = T2
                Gen_Stufe(iT) = Gen_Stuf
                Call Test2(T2, i22)
                Gen_Stuf -= 1

            End If
        Next
NF_Ex100:
        Call Nachfahren_Tab_Insert(iT)

    End Sub

    REM *********************************************************************
    REM *  Subgeneration auflösen                                           *
    REM *********************************************************************
    Public Shared Sub Test2(ByVal T6 As String, ByVal i23 As Integer)
        Dim T9 As String
        Dim T8 As String

        For i88 = 0 To i23
            Gen_Stuf += 1
            T8 = Mid(Gen_Help(i88), 1, Gen_Lg)
            T9 = Mid(Gen_Help(i88), 1 + Gen_Lg, Gen_Lg)
            If T6 = T8 Then
                iT += 1
                Gen_ID(iT) = T9
                Gen_Stufe(iT) = Gen_Stuf
                T_Search(Gen_Stuf) = T9
                Call Test2(T9, i23)
                Gen_Stuf -= 1
            Else
                Gen_Stuf -= 1
                T6 = T_Search(Gen_Stuf)
            End If
        Next

    End Sub

    REM ***************************************************
    REM *  Einfügen der notwendigen Daten in Hilfstabelle *
    REM ***************************************************
    Public Shared Sub Nachfahren_Tab_Insert(ByVal i23 As Integer)

        Call ClearGenZeilen(i23)
        For i24 = 0 To i23

            dbl_ID = Gen_ID(i24)
            Call Person_Read_t01_Basis()
            Gen_Zeil1(i24) = Gen_Stufe(i24).ToString("##0") + " "
            Call V_GradN(i24)
            Gen_Zeil2(i24) = Gen_Grad

            If Gen_Stufe(i24) > 0 Then
                For l = 1 To Gen_Stufe(i24)
                    Gen_Zeil3(i24) = Gen_Zeil3(i24) + "."
                Next
            End If
            Gen_Zeil3(i24) = Gen_Zeil3(i24) + p_str_Name
            If p_str_GebName <> p_str_Name Then Gen_Zeil3(i24) += ", geb. " + p_str_GebName
            Gen_Zeil3(i24) += ", " + p_str_Vorname

            Gen_Zeil4(i24) = dbl_ID.ToString("####0")
            Gen_Zeil5(i24) = p_int_Vater.ToString("####0")
            Gen_Zeil6(i24) = p_int_Mutter.ToString("####0")
            Gen_Zeil7(i24) = "*" + p_str_GDat_TT + "." + p_str_GDat_MM + "." + p_str_GDat_JJ
            Gen_Zeil8(i24) = "+" + p_str_SDat_TT + "." + p_str_SDat_MM + "." + p_str_SDat_JJ
        Next

        int_Anz_Seit = Gen_Zeilen / int_NF_Seit_Max
        dbl_Anz_Seit = int_Anz_Seit + int_NF_Seit_Max
        If dbl_Anz_Seit < Gen_Zeilen Then int_Anz_Seit += 1
        int_Anz_Sub = 0
        Gen_Merk_Zeile = 0

    End Sub

    Public Shared Sub V_GradN(ByVal i25 As Integer)
        Gen_Grad = ""
        If Gen_Stufe(i25) = 0 Then Gen_Grad = "Proband"
        If Gen_Stufe(i25) = 1 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Sohn"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Tochter"
        End If
        If Gen_Stufe(i25) = 2 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Enkel"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Enkelin"
        End If
        If Gen_Stufe(i25) = 3 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Urenkel"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Urenkelin"
        End If
        If Gen_Stufe(i25) > 3 Then
            If p_str_Geschl = "M" Then Gen_Grad = "Ur(" + (Gen_Stufe(i25) - 2).ToString + ")enkel"
            If p_str_Geschl = "W" Or p_str_Geschl = "F" Then Gen_Grad = "Ur(" + (Gen_Stufe(i25) - 2).ToString + ")enkelin"
        End If
    End Sub


End Class
